
//javascript and css code, link: https://techtutorialsx.wordpress.com/2016/10/15/esp8266-http-server-serving-html-javascript-and-css/
// http://circuits4you.com/2016/12/16/esp8266-web-server-html/


#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>

#include <Chrono.h> 
//Chrono secChrono(Chrono::SECONDS);
Chrono myChrono; 

#include <OneWire.h>
#include <DallasTemperature.h>
#define Wire_PIN D4
OneWire oneWire(Wire_PIN);
DallasTemperature sensors(&oneWire);
DeviceAddress Sensor_kint = { 0x28, 0xFF, 0x10, 0x25, 0x3C, 0x4, 0x0, 0x9B };   // - 0.63
// kint - Chip = DS18B20, ROM = 0x28, 0xFF, 0x10, 0x25, 0x3C, 0x4, 0x0, 0x9B  // +0.75
DeviceAddress Sensor_bent = { 0x28, 0xFF, 0x2A, 0x27, 0x3C, 0x4, 0x0, 0xA5 };
// bent - Chip = DS18B20, ROM = 0x28, 0xFF, 0x2A, 0x27, 0x3C, 0x4, 0x0, 0xA5  // 0.00
  
double t_b_h = 0;
int t_b_egyesek, t_b_tizedesek;
double t_b, pr_t_b, prr_t_b = 0;
       double t_k, pr_t_k, prr_t_k = 0;
double t_beall = 5.00;   
double hys = 0.05;
String html = "";  String prev_html = "";

int m_nap, m_ora, m_perc, m_sec, m;
boolean futes, pr_futes = false;
int  f, f_sec, f_perc, f_ora, f_nap = 0;


  // eeprom
 #include <EEPROM.h>
 const byte EEPROM_VALIDATOR = 9; //random number
 const byte EEPROM_CONFIGADDRESS = 0;
 struct config_t { byte Validator;
                   double t_beall; 
                   double hys;
                   double t_b_egyesek, t_b_tizedesek;
                   int m_nap, m_ora, m_perc, m;
                   byte ValidatorX2; } EEPROM_DATA;
#define mentes_pin D6   // D6 a Wemos-on szerelve

const char* ssid = "***";
const char* pass = "***";
const char* host = "thermo1"; 
  //IPAddress IP(192,168,0,166);
  IPAddress Gate(192,168,0,1);
  IPAddress Subnet(255,255,255,0);
//  uint8_t macc[] = {0x00, 0x01, 0x02, 0x03, 0x04, 0x05};
  // byte mac[6]; 
ESP8266WebServer server(82);  // - thermosz - vemos d1 mini
//ESP8266WebServer server(85);
const char* esp_ssid = "thermo";
const char* esp_pass = "thermo";
  IPAddress esp_ip(192,168,6,1);
  IPAddress esp_gate(192,168,1,254);
  IPAddress esp_subnet(255,255,255,0); //- See more at: http://www.esp8266.com/viewtopic.php?f=29&t=12124


#define led D7
#define led_P_k D1
#define led_Z_k D2
//#include <Metro.h>
//int state = HIGH;
//Metro ledMetro = Metro();

const int rezso = D5;
int a, b, c = 0;
int crt = 0;

void setup() {
  Serial.begin(115200);
  #ifndef ESP8266
  while (!Serial); // for Leonardo/Micro/Zero
  #endif
  pinMode(rezso, OUTPUT); digitalWrite(rezso,LOW);
  pinMode(led_P_k, OUTPUT); digitalWrite(led_P_k,LOW);
  pinMode(led_Z_k, OUTPUT); digitalWrite(led_Z_k,LOW);
  pinMode(led, OUTPUT); digitalWrite(led,LOW);
  pinMode(mentes_pin,INPUT_PULLUP);
  attachInterrupt(mentes_pin,mentes,CHANGE); 
    digitalWrite(led_P_k, !futes);  digitalWrite(led_Z_k, futes); delay(100); 
  sensors.begin();
    digitalWrite(led_P_k, futes);   digitalWrite(led_Z_k, !futes); delay(100); 
   sensors.setResolution(Sensor_kint, 12);
   sensors.setResolution(Sensor_bent, 12);
    digitalWrite(led_P_k, !futes);   digitalWrite(led_Z_k, futes); delay(100); 
   Serial.println();Serial.println();Serial.println();
    WiFi.mode(WIFI_AP_STA);  // WiFi.mode(m): set mode to WIFI_AP, WIFI_STA, WIFI_AP_STA or WIFI_OFF
 //  bool wifi_set_macaddr(uint8 if_index, uint8 *macc);
//  WiFi.softAPConfig(esp_ip, esp_gate, esp_subnet); //- See more at: http://www.esp8266.com/viewtopic.php?f=29&t=12124
  WiFi.softAP(esp_ssid, esp_pass); // sajat ssid es pass
  WiFi.begin(ssid, pass);
  Serial.println("");
  Serial.print("WIFI_AP mode: IP: ");   Serial.println(WiFi.softAPIP());
  Serial.print("              SSID: "); Serial.println(esp_ssid);
  Serial.print("              PASS: "); Serial.println(esp_pass);
  Serial.print("              MAC: ");  Serial.println(WiFi.softAPmacAddress());
   digitalWrite(led_P_k, futes);   digitalWrite(led_Z_k, !futes); delay(100); 
  
 // WiFi.macAddress(DE:C1:A5:51:F1:ED);
  //WiFi.macAddress(DE AD BE EF 7A C0);
  
   // wifi_set_macaddr(SOFTAP_IF, macc);
   //WiFi.config(IP, Gate, Subnet);
 // WiFi.config(IP);
  WiFi.hostname(host);
  
     digitalWrite(led_P_k, !futes);   digitalWrite(led_Z_k, futes); delay(100); 
   Serial.print("Wait for connection ");
  int x = 0;
  while ((WiFi.status() != WL_CONNECTED) && (x < 30)) { digitalWrite(led_P_k, futes);   digitalWrite(led_Z_k, !futes); delay(550);  
                                                        x++;
                                                        digitalWrite(led_P_k, !futes);   digitalWrite(led_Z_k, futes); delay(550); 
                                                        Serial.print(" ."); 
                                                        }
  // int i = 0;
 //  digitalWrite(led, LOW); 
 //  while (WiFi.status() != WL_CONNECTED && i++ < 20) { digitalWrite(led, HIGH); delay(1000); digitalWrite(led, LOW); Serial.print(" ."); }
     digitalWrite(led_P_k, futes);   digitalWrite(led_Z_k, !futes); delay(100); 
      Serial.println();
                                                  
        digitalWrite(led_P_k, !futes);   digitalWrite(led_Z_k, futes); delay(100); 
    WiFi.printDiag(Serial); 
    Serial.printf("signal %3i dBm\r\n", WiFi.RSSI()); Serial.println();
  Serial.println();
     digitalWrite(led_P_k, futes);   digitalWrite(led_Z_k, !futes); delay(100); 
  
   
  
  EEPROM.begin(512); 
        digitalWrite(led_P_k, !futes);   digitalWrite(led_Z_k, futes); delay(100);        
  loadConfiguration();
        digitalWrite(led_P_k, futes);   digitalWrite(led_Z_k, !futes); delay(100); 
  server.on("/", handleRoot);
  server.on("/hyst", hysteresis);
  server.on("/reset", resett);
  server.on("/login", handleLogin);  
 // server.on("/inline", [](){ server.send(200, "text/plain", "this works without need of authentification"); });
  
  server.onNotFound(handleNotFound);
  //here the list of headers to be recorded
  const char * headerkeys[] = {"User-Agent","Cookie"} ;
  size_t headerkeyssize = sizeof(headerkeys)/sizeof(char*);
  //ask server to track these headers
  server.collectHeaders(headerkeys, headerkeyssize );
  server.begin();
  Serial.println("HTTP server started");

  if(MDNS.begin(host)) { Serial.print("MDNS responder started.   "); } Serial.println("HTTP server started.");
    MDNS.addService("http", "tcp", 82);
    
  delay(100);
  digitalWrite(led_P_k,LOW);
  digitalWrite(led_Z_k,LOW);
  myChrono.restart();
  
}

void loop() {
  
 if (myChrono.hasPassed(2000, true)) { Serial.print(". "); 
                                       myChrono.restart();  digitalWrite(led, LOW); delay(50); digitalWrite(led, HIGH);   
                                       f++; if(f > 29) { f = 0; f_perc++; if(f_perc > 59) { if(f % 15 == 0){ if(WiFi.status() != WL_CONNECTED){ saveConfiguration(); ESP.restart(); }}
                                                                                            f_perc = 0; f_ora++; if(f_ora > 23) { f_ora = 0; f_nap++; } } }                                       
                                       crt++; if(crt > 2) { crt = 0; 
                                                            sensor_read(); // Serial.print("sensor read = ");
                                                            if(t_b > (t_b_h + hys)) { t_b_h = (t_b - hys); }
                                                            if(t_b < (t_b_h - hys)) { t_b_h = (t_b + hys); }    // Serial.print(t_b_h); Serial.print(" fok");
                                                            if(t_b_h <= t_beall) { //Serial.println("  - REZSO -");
                                                              m++; if(m > 9) { m = 0; m_perc++; if(m_perc > 59) { m_perc = 0; m_ora++; if(m_ora > 23) { m_ora = 0; m_nap++; } } }
                                                              futes = true; } else { futes = false; } } }                    
                            

    digitalWrite(rezso, futes);  
    digitalWrite(led_P_k, futes);
    digitalWrite(led_Z_k, !futes);
  
  server.handleClient();
 
}
